

#include <allegro.h>
#include <iostream>
#include <vector>
#include <sstream>
#include <math.h>
#include <list>
#include <map>
#include <fstream>
#include <stack>
#include <algorithm>
#include <queue>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif


using namespace std;


typedef double num;

const int SCREEN_WIDTH=320;
const int SCREEN_HEIGHT=240;

const int RADIUS = 5;
const int BASERADIUS = 37;

struct Pos {
	float x;
	float y;
};


int magenta;
int red;
int black;
int white;
int green;
int blue;
int yellow;

int target[2];
bool inbase[2];

Pos pos[2];
Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

int influencedcount[2];
bool influenced[CIRCLECOUNT];
int influencedtimer[CIRCLECOUNT];
Pos influencedpos[CIRCLECOUNT];
//used for targetting numerical enemies


BITMAP* buffer;


#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"

const int ts=13;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

bool collides(Pos& a, Pos& b)
{
	float dx = (a.x-b.x);
	float dy = (a.y-b.y);

	return (dx*dx+dy*dy <= RADIUS*RADIUS);
}

bool showstory=false;

const char* storytext[7][4]=
{
{"Get all ball",
"before time runs out.",
"player 1: wsadyu",
"player 2: up/down/left/right/space/m"}
};

int score[2];
char scoretxt1[30];
char scoretxt2[30];
char timetext[30];
int gametimer;
const int FRAME_RATE=45;
bool spacepressed;
int storyprogress;
bool finishedstory;
bool endmode;
int pauseafter;

class StoryLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			storyprogress=0;
			finishedstory=false;
			pauseafter=0;
			playmusic(13);
		}
		static bool quitcondition()
		{
			return quit && pauseafter==0;
		}
		static void logic()
		{

			if (pauseafter>0)
				pauseafter--;

			if (key[KEY_ESC]&&!escpressed)
				quit=true;

			if (key[KEY_SPACE])
			{
				quit=true;
			}
			else
			{
				spacepressed=false;
			}
		}
		static void draw()
		{
			clear_to_color(buffer, makecol(0,0,0));
			if (quit)
				return;

            textout_centre_ex(buffer, font, storytext[storyprogress][0], 160, 50, makecol(255,255,255), makecol(0,0,0));
			textout_centre_ex(buffer, font, storytext[storyprogress][1], 160, 65, makecol(255,255,255), makecol(0,0,0));
			textout_centre_ex(buffer, font, storytext[storyprogress][2], 160, 80, makecol(255,255,255), makecol(0,0,0));
			textout_centre_ex(buffer, font, storytext[storyprogress][3], 160, 95, makecol(255,255,255), makecol(0,0,0));

		}
	};

class IntroLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_ex(buffer, font, "increpare presents", 4, 50, makecol(100,100,100), -1);

		}
	};

int endmenutimer;

class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			endmode=false;
			endmenutimer=0;
			playmusic(5);
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			showstory=false;

		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;

				if (endmenutimer==10)
					stopmusic();

				return;
			}

			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];



			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+2)%3;
					playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%3;
					playsample(1);
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
					}
					else if (selected==1)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
						showstory=true;
					}
					else
					{
						quit=true;
						playsample(0);
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
            clear_to_color(buffer,black);

			textout_centre_ex(buffer, font, "Goal Game", SCREEN_WIDTH/2, 20, white, -1);
			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,font,"START",100,60,makecol(100,100,100),makecol(255,255,255));
				textout_ex(buffer,font,"Instructions",100,72,makecol(255,255,255),-1);
				textout_ex(buffer,font,"Exit",100,84,makecol(255,255,255),-1);
			}
			else if (selected==1)
			{
				textout_ex(buffer,font,"Start",100,60,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,font,"INSTRUCTIONS",100,72,makecol(100,100,100),makecol(255,255,255));
				textout_ex(buffer,font,"Exit",100,84,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,font,"Start",100,60,makecol(255,255,255),-1);
				textout_ex(buffer,font,"Instructions",100,72,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,font,"EXIT",100,84,makecol(100,100,100),makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;
int endtimer=0;

void winlevel()
{
	if (endtimer>0)
		return;

	endtimer=120;
	playmusic(6);

}

void loselevel()
{
	stopmusic();
	endtimer=120;
}


float distsq(Pos a, Pos b)
{
	return ((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));
}
const int MAX_INFLUENCE=30;

bool presseda,pressedb;

void calcscores()
{
	bool modified=false;
	score[0]=0;
	score[1]=0;
	for (int i=0;i<CIRCLECOUNT;i++)
	{
		if (distsq(base[0],circles[i])<BASERADIUS*BASERADIUS)
		{
			score[0]++;
			modified=true;
		}
		if (distsq(base[1],circles[i])<BASERADIUS*BASERADIUS)
		{
			score[1]++;
			modified=true;
		}
	}
}

void modifytext()
{	
	calcscores();
	sprintf(scoretxt1,"p1: %d (%d/3)",score[0],influencedcount[0] );
	sprintf(scoretxt2,"p2: %d (%d/3)",score[1],influencedcount[1] );
}
class GameLoop
	{
	public:

		static void initialize()
		{
			score[0]=0;
			score[1]=0;
			presseda=true;
			pressedb=true;
			influencedcount[0]=3;
			influencedcount[1]=3;
            quit=false;
            leave=false;
			gametimer=FRAME_RATE*30;

			if (gametimer%FRAME_RATE==0)
				sprintf(timetext,"time: %d", gametimer/FRAME_RATE);
			
			
			for (int i=0;i<CIRCLECOUNT;i++)
			{
				influenced[i]=false;
				influencedtimer[i]=0;
			}
			
            for (int i=0;i<2;i++)
            {
                base[i].x=BASERADIUS*1.5+ (rand()%(SCREEN_WIDTH-BASERADIUS*3));
                base[i].y=BASERADIUS*1.5+ (rand()%(SCREEN_HEIGHT-BASERADIUS*3));
                pos[i]=base[i];
            }

            for (int i=0;i<CIRCLECOUNT;i++)
            {
                circles[i].x=RADIUS*2+ (rand()%(SCREEN_WIDTH-RADIUS*6));
                circles[i].y=RADIUS*2+ (rand()%(SCREEN_HEIGHT-RADIUS*6));
                circelvels[i].x=0;
                circelvels[i].y=0;
            }
			influencedcount[0]=3;
			influencedcount[1]=3;
			modifytext();
		}

		static bool quitcondition()
		{
			return quit||leave;
		}

		static void logic()
		{
			gametimer--;
			if (gametimer==0)
			{
				playsample(7,400);
				leave=true;
				return;
			}
			
			if (gametimer%FRAME_RATE==0)
				sprintf(timetext,"time: %d", gametimer/FRAME_RATE);
			
		    const int v=2;
			
			for (int i=0;i<CIRCLECOUNT;i++)
			{

				if (influenced[i]>0)
				{	
					influencedtimer[i]--;
					//move
					float dx=circles[i].x-influencedpos[i].x;
					float dy=circles[i].y-influencedpos[i].y;
					float l = sqrt(dx*dx+dy*dy);
					
					circles[i].x+=dx*1.0f/l;
					circles[i].y+=dy*1.0f/l;
					if (influencedtimer[i]<=0)
						influenced[i]=0;
				}
			}

			
			if (!presseda && key[KEY_M] && influencedcount[0]>0)
			{
				for (int i=0;i<CIRCLECOUNT;i++)
				{
					
					if (distsq(circles[i],pos[0])<(60*60))
					{
						influenced[i]=true;
						influencedpos[i]=pos[0];
						influencedtimer[i]=MAX_INFLUENCE;
					}
				}
				influencedcount[0]--;
				
				sprintf(scoretxt1,"p1: %d (%d/3)",score[0],influencedcount[0] );
				sprintf(scoretxt2,"p2: %d (%d/3)",score[1],influencedcount[1] );
				
			}
			presseda=key[KEY_M];
			
			if (!pressedb && key[KEY_U] && influencedcount[1]>0)
			{
				for (int i=0;i<CIRCLECOUNT;i++)
				{
					if (distsq(circles[i],pos[1])<(60*60))
					{
						influenced[i]=true;
						influencedpos[i]=pos[1];
						influencedtimer[i]=MAX_INFLUENCE;
						
					}
				}
				influencedcount[1]--;
				
				sprintf(scoretxt1,"p1: %d (%d/3)",score[0],influencedcount[0] );
				sprintf(scoretxt2,"p2: %d (%d/3)",score[1],influencedcount[1] );
				
			}
			pressedb=key[KEY_U];
			
            if (key[KEY_ESC])
            {
                escpressed=true;
                quit=true;
            }
            else
            {
                escpressed=false;
            }

			bool moving[2]={false,false};
            if (key[KEY_UP])
            {
                if (pos[0].y-RADIUS>0)
				{
					moving[0]=true;
                    pos[0].y-=v;
				}
            }
            if (key[KEY_DOWN])
            {
                if (pos[0].y+RADIUS<SCREEN_HEIGHT)
				{
					moving[0]=true;
                    pos[0].y+=v;
				}
            }
            if (key[KEY_LEFT])
            {
                if (pos[0].x-RADIUS>0)
				{
					moving[0]=true;
                    pos[0].x-=v;
				}
            }
            if (key[KEY_RIGHT])
            {
                if (pos[0].x+RADIUS<SCREEN_WIDTH)
				{
					moving[0]=true;
                    pos[0].x+=v;
				}
            }
            if (key[KEY_W])
            {
                if (pos[1].y-RADIUS>0)
				{
					moving[1]=true;
                    pos[1].y-=v;
				}
            }
            if (key[KEY_S])
            {
                if (pos[1].y+RADIUS<SCREEN_HEIGHT)
				{
					moving[1]=true;
                    pos[1].y+=v;
				}
            }
            if (key[KEY_A])
            {
                if (pos[1].x-RADIUS>0)
				{
					moving[1]=true;
                    pos[1].x-=v;
				}
            }
            if (key[KEY_D])
            {
                if (pos[1].x+RADIUS<SCREEN_WIDTH)
				{
					moving[1]=true;
                    pos[1].x+=v;
				}
            }
			
			
			if (target[0]>=0)
			{
				circles[target[0]].x=pos[0].x;
				circles[target[0]].y=pos[0].y;
			}
			if (target[1]>=0)
			{
				circles[target[1]].x=pos[1].x;
				circles[target[1]].y=pos[1].y;
			}
			target[0]=-1;
			target[1]=-1;
			
			float curdistmin[2]={2*RADIUS,2*RADIUS};
			for (int i=0;i<CIRCLECOUNT;i++)
			{
				if (distsq(circles[i],pos[0])<(RADIUS*RADIUS*4))
				{
					if (distsq(circles[i],pos[0])<curdistmin[0])
					{
						if (!key[KEY_SPACE])
							target[0]=i;
						curdistmin[0]=distsq(circles[i],pos[0]);
					}
				}
				
				if (distsq(circles[i],pos[1])<(RADIUS*RADIUS*4))
				{					
					if (distsq(circles[i],pos[1])<curdistmin[1])
					{
						if (!key[KEY_Y])
							target[1]=i;
						curdistmin[1]=distsq(circles[i],pos[1]);
					}
				}
			}
			
			inbase[0]=distsq(pos[0], base[0])<=BASERADIUS*BASERADIUS;
			inbase[1]=distsq(pos[1], base[1])<=BASERADIUS*BASERADIUS;
			modifytext();
		}

		static void draw()
		{


			clear_to_color(buffer, black);

            circle(buffer,base[0].x,base[0].y,BASERADIUS,green);
            circle(buffer,base[1].x,base[1].y,BASERADIUS,blue);

            for (int i=0;i<CIRCLECOUNT;i++)
            {
				if (target[0]==i || target[1]==i)
					circle(buffer,circles[i].x,circles[i].y,RADIUS,red);
				else
					circlefill(buffer,circles[i].x,circles[i].y,RADIUS,red);
					
            }

			if (inbase[0])
			{
				rect(buffer,pos[0].x-RADIUS-1,pos[0].y-RADIUS-1,pos[0].x+RADIUS+1,pos[0].y+RADIUS+1,makecol(100,255,100));
				
			}
			else
			{
				rect(buffer,pos[0].x-RADIUS-1,pos[0].y-RADIUS-1,pos[0].x+RADIUS+1,pos[0].y+RADIUS+1,green);
			}
			
			if (inbase[1])
			{
				
				rect(buffer,pos[1].x-RADIUS-1,pos[1].y-RADIUS-1,pos[1].x+RADIUS+1,pos[1].y+RADIUS+1,makecol(100,100,255));
			}
			else
			{
				rect(buffer,pos[1].x-RADIUS-1,pos[1].y-RADIUS-1,pos[1].x+RADIUS+1,pos[1].y+RADIUS+1,blue);
			}
			
			textout_ex(buffer, font, timetext, 5, 5, white, -1);
			textout_ex(buffer, font, scoretxt1, 5, 15, green, -1);
			textout_ex(buffer, font, scoretxt2, 5, 25, blue, -1);
		}

	};



class GameOverLoop
	{
	public:
		static void initialize()
		{
			
			spacepressed=true;
			quit=false;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			playsample(6,200);
		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			
			
			if ((key[KEY_ESC]&&!escpressed)||key[KEY_SPACE])
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];
			
		}
		
		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "your final scores were:", 300/2, 5*10/2,white, -1);
			
			sprintf(scoretxt1,"player 1 score:%d",score[0]);
			textout_centre_ex(buffer, font, scoretxt1, 300/2, 5*10/2+15,green, -1);
			
			sprintf(scoretxt1,"player 2 score:%d",score[1]);
			textout_centre_ex(buffer, font, scoretxt1, 300/2, 5*10/2+30,blue, -1);
			
			
			if (score[0]>score[1])
			{
				textout_centre_ex(buffer, font, "player 1 wins", 300/2, 5*10/2+45,green, -1);				
			}
			else if (score[1]>score[0])
			{
				textout_centre_ex(buffer, font, "player 2 wins", 300/2, 5*10/2+45,blue, -1);				
			}
			else 
			{
				textout_centre_ex(buffer, font, "a joyous draw occurred", 300/2,5*10/2+45,white, -1);				
			}
		}
	};


template<class T>
void loop()
{

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        stretch_blit(buffer, screen, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0, 640, 480);

	}
}


void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAME_RATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	red=makecol(255,0,0);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);


}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:

	loop<TitleLoop>();
	if (quit)
	goto end;

	if (showstory)
	{
		loop<StoryLoop>();
		quit=false;
		playmusic(14);
		goto titletag;
	}
	else
	{
		playmusic(13);
		loop<GameLoop>();
		if (quit)
		{
			quit=false;
			goto titletag;
		}
		else
		{
			loop<GameOverLoop>();
			quit=false;
			leave=false;
			TitleLoop::begin=false;
			goto titletag;
		}
	}
end:
	return 0;

}
END_OF_MAIN()
