/*
 *  sound.hpp
 *  Template
 *
 *  Created by increpare on 16/01/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <aldumb.h>

const int pan = 128;
const int volume = 128;

DUH* music[15];
SAMPLE* sample[12];

AL_DUH_PLAYER *dplay; /* Holds the current playback state. */

void stopmusic()
{
	//BASS_ChannelStop(curplay);
	if (dplay!=NULL)
	{
		al_stop_duh(dplay);
		dplay=NULL;
	}
}

void playmusic(int i)
{

	stopmusic();
	dplay=al_start_duh(music[i],1,0,0.2f, 4096,4000);
}

void playsample(int i, int pitch=1000)
{
	play_sample(sample[i], volume, pan, pitch, 0);
}

void init_sound()
{

	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	atexit(&dumb_exit);
	set_mixer_quality(0);
	dumb_register_stdfiles();

	sample[0] = load_sample("wav/blip.wav");
	sample[1] = load_sample("wav/select.wav");
	sample[2] = load_sample("wav/die.wav");
	sample[3] = load_sample("wav/hitboss.wav");
	sample[4] = load_sample("wav/lethalexplosion.wav");
	sample[5] = load_sample("wav/nonlethalhit.wav");
	sample[6] = load_sample("wav/target.wav");
	sample[7] = load_sample("wav/bigbang.wav");
	sample[8] = load_sample("wav/bigbang2.wav");
	sample[9] = load_sample("wav/laser.wav");
	sample[11] = load_sample("wav/targeton.wav");

	//load music
	music[0] = dumb_load_xm_quick("xm/TRIGGERboss1.xm");
	music[1] = dumb_load_xm_quick("xm/TRIGGERboss2.xm");
	music[2] = dumb_load_xm_quick("xm/TRIGGERboss3.xm");
	music[3] = dumb_load_xm_quick("xm/TRIGGERboss4.xm");
	music[4] = dumb_load_xm_quick("xm/TRIGGERboss4.xm");
	music[5] = dumb_load_xm_quick("xm/TRIGGERcalm.xm");
	music[6] = dumb_load_xm_quick("xm/TRIGGERfinishjingle.xm");
	music[7] = dumb_load_xm_quick("xm/TRIGGERlevel1.xm");
	music[8] = dumb_load_xm_quick("xm/TRIGGERlevel2.xm");
	music[9] = dumb_load_xm_quick("xm/TRIGGERlevel3.xm");
	music[10] = dumb_load_xm_quick("xm/TRIGGERlevel4.xm");
	music[11] = dumb_load_xm_quick("xm/TRIGGERlevel5.xm");
	music[12] = dumb_load_xm_quick("xm/TRIGGERselectstage.xm");
	music[13] = dumb_load_xm_quick("xm/TRIGGERstory.xm");
	music[14] = dumb_load_xm_quick("xm/TRIGGERtitle.xm");


}
